#include <afxwin.h>
#include <afxcmn.h>

#include "ShutDWNDlg.h"

#define UM_MESSAGEBOX WM_USER + 100

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CShutDWNDlg::CShutDWNDlg( CWnd* pParent ) : CDialog( CShutDWNDlg::IDD, pParent ),
											m_pThread( NULL )
{
	//{{AFX_DATA_INIT(CShutDWNDlg)
	m_remName = "";
	m_addText = "";
	m_timeOut = 60;
	m_accName = "Administrator";
	m_accPasswd = "";
	m_accDomain = "";
	
	//}}AFX_DATA_INIT
	m_nType = 0;
}

void CShutDWNDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange( pDX );

	//{{AFX_DATA_MAP(CShutDWNDlg)
	DDX_Control( pDX, IDC_SPIN, m_btnSpin );

	DDX_Text( pDX, IDC_REM_NAME, m_remName );
	DDX_Text( pDX, IDC_ADD_TEXT, m_addText );
	DDX_Text( pDX, IDC_TIMEOUT, m_timeOut );
	DDX_Text( pDX, IDC_EDIT_ACCNAME, m_accName );
	DDX_Text( pDX, IDC_EDIT_ACCPASSW, m_accPasswd );
	DDX_Text( pDX, IDC_EDIT_ACCDOMAIN, m_accDomain );
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShutDWNDlg, CDialog)
//{{AFX_MSG_MAP(CShutDWNDlg)
	ON_BN_CLICKED(IDC_BUTTON_ABORT, OnAbort)
//}}AFX_MSG_MAP
	ON_MESSAGE( UM_MESSAGEBOX, OnMessageBox )
END_MESSAGE_MAP()

LRESULT CShutDWNDlg::OnMessageBox( WPARAM wParam, LPARAM lParam )
{
	MessageBox( (LPCTSTR)wParam, NULL, (UINT)lParam );
	EnableControls( TRUE );
	m_pThread = NULL;
	return 0;
}

BOOL CShutDWNDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_hIcon = AfxGetApp()->LoadIcon( MAKEINTRESOURCE( IDI_ICON ) );

	SetIcon( m_hIcon, TRUE );
	SetIcon( m_hIcon, FALSE );

	UDACCEL acc[ 5 ];
	acc[ 0 ].nInc = 60;
	acc[ 0 ].nSec = 1;
	acc[ 1 ].nInc = 120;
	acc[ 1 ].nSec = 5;
	acc[ 2 ].nInc = 180;
	acc[ 2 ].nSec = 10;
	acc[ 3 ].nInc = 240;
	acc[ 3 ].nSec = 15;
	acc[ 4 ].nInc = 300;
	acc[ 4 ].nSec = 20;
	
	m_btnSpin.SetAccel( 5, &acc[ 0 ] );
	m_btnSpin.SetRange32( 0, 3600000 );
	UpdateData( FALSE );
	
	return TRUE;
}

void CShutDWNDlg::OnOK() 
{
	if( FALSE == UpdateData() )
		return;

	if( NULL == m_pThread )
	{
		CWaitCursor wc;

		EnableControls( FALSE );

		m_nType = 1; // To Initiate a shut down

		m_pThread = AfxBeginThread( ShutDownThread, this );
	}
}

void CShutDWNDlg::OnAbort() 
{
	if( FALSE == UpdateData() )
		return;

	if( NULL == m_pThread )
	{
		CWaitCursor wc;

		EnableControls( FALSE );

		m_nType = 0; // To abort a shut down

		m_pThread = AfxBeginThread( ShutDownThread, this );
	}
}

UINT CShutDWNDlg::DisplayError( LPDWORD lastErr )
{
	LPVOID lpMsgBuf;
	FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |
				   FORMAT_MESSAGE_IGNORE_INSERTS, NULL, lastErr ? ( *lastErr ) : GetLastError(),
				   MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
				   (LPTSTR)&lpMsgBuf, 0, NULL );

	return (UINT)SendMessage( UM_MESSAGEBOX, (WPARAM)lpMsgBuf, (LPARAM)( MB_OK | MB_ICONEXCLAMATION ) );
}

UINT AFX_CDECL CShutDWNDlg::ShutDownThread( LPVOID lpParam )
{
	CShutDWNDlg *pDlg = (CShutDWNDlg*)lpParam;

	char pName[ 128 ] = { 0 };
	char pPasswd[ 128 ] = { 0 };
	char pDomain[ 128 ] = { 0 };

	char pRemoteName[ 260 ] = { 0 };
	char pMessage[ 512 ] = { 0 };

	HANDLE hLogonToken;
	HANDLE hAdminToken;
	HANDLE hThreadToken;
	TOKEN_PRIVILEGES tkp;

	if( 0 < pDlg->m_accName.GetLength() )
		strcpy( pName, pDlg->m_accName );

	if( 0 < pDlg->m_accPasswd.GetLength() )
		strcpy( pPasswd, pDlg->m_accPasswd );

	if( 0 < pDlg->m_accDomain.GetLength() )
		strcpy( pDomain, pDlg->m_accDomain );

	if( FALSE == LogonUser( pName, pDomain, pPasswd,
							LOGON32_LOGON_INTERACTIVE,
							LOGON32_PROVIDER_DEFAULT,
							&hLogonToken ) )
	{	
		return pDlg->DisplayError();
	}

	if( FALSE == DuplicateTokenEx( hLogonToken, TOKEN_ALL_ACCESS, NULL, SecurityIdentification, TokenPrimary, &hAdminToken ) )
		return pDlg->DisplayError();

	if( FALSE == ImpersonateLoggedOnUser( hAdminToken ) )
		return pDlg->DisplayError();

 	if( FALSE == OpenThreadToken( GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, TRUE, &hThreadToken ) )
	{
		RevertToSelf();
		return pDlg->DisplayError();
	}

	// Get the LUID for shutdown privilege.
	LookupPrivilegeValue( NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid );

	tkp.PrivilegeCount = 1;
	tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

	// Get shutdown privilege for this thread.
	AdjustTokenPrivileges( hThreadToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0 ); 
	if( GetLastError() != ERROR_SUCCESS )
	{
		RevertToSelf();
		return pDlg->DisplayError();
	}

	if( 0 < pDlg->m_remName.GetLength() )
		strcpy( pRemoteName, pDlg->m_remName );

	if( 0 < pDlg->m_addText.GetLength() )
		strcpy( pMessage, pDlg->m_addText );

	if( pDlg->m_nType )
	{
		if( FALSE == InitiateSystemShutdown( pRemoteName, pMessage, pDlg->m_timeOut, FALSE, FALSE ) )
		{
			RevertToSelf();
			return pDlg->DisplayError();
		}
	}
	else
	{
		if( FALSE == AbortSystemShutdown( pRemoteName ) )
		{
			RevertToSelf();
			return pDlg->DisplayError();
		}
	}

	// Disable shutdown privilege.
	tkp.Privileges[0].Attributes = 0;
	AdjustTokenPrivileges( hThreadToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0 );
	if( GetLastError() != ERROR_SUCCESS )
	{
		RevertToSelf();
		return pDlg->DisplayError();
	}

	RevertToSelf();
	pDlg->EnableControls( TRUE );
	pDlg->m_pThread = NULL;
	return 0;
}

void CShutDWNDlg::EnableControls( BOOL bEnable )
{
	GetDlgItem( IDC_TIMEOUT )->EnableWindow( bEnable );
	GetDlgItem( IDC_REM_NAME )->EnableWindow( bEnable );
	GetDlgItem( IDC_ADD_TEXT )->EnableWindow( bEnable );
	GetDlgItem( IDC_EDIT_ACCNAME )->EnableWindow( bEnable );
	GetDlgItem( IDC_EDIT_ACCPASSW )->EnableWindow( bEnable );
	GetDlgItem( IDC_EDIT_ACCDOMAIN )->EnableWindow( bEnable );
	GetDlgItem( IDOK )->EnableWindow( bEnable );
	GetDlgItem( IDCANCEL )->EnableWindow( bEnable );
	GetDlgItem( IDC_BUTTON_ABORT )->EnableWindow( bEnable );
	UpdateWindow();
}
